Unit zf21e_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTZF11_p;

procedure zf21e(FUNCD :Proc_F3E; A :Extended; B :Extended; EPS :Extended;
                var ROOT :Extended; ITMAX :Integer; var IERR :Integer);

implementation

procedure zf21e(FUNCD :Proc_F3E; A :Extended; B :Extended; EPS :Extended;
                var ROOT :Extended; ITMAX :Integer; var IERR :Integer);
var
I :Integer;
F,DF,DX :Extended;
const
ZERO :Extended = 0.0e0;
label
_10,_20,_30,_40;
begin
IERR := 0;
ROOT := 0.5e0*(A+B);
for I:=1 to ITMAX do
 begin
  _ZF21RR.elm1:= I;
  FUNCD(ROOT,F,DF);
  DX := F/DF;
  ROOT := ROOT-DX;
  if ( (A-ROOT)*(ROOT-B) < ZERO ) 
   then goto _20;
  if ( Abs(DX) < Abs(EPS) ) 
   then goto _40;
_10:
 end;
IERR := 65;
goto _30;
_20:
IERR := 66;
_30:
UTZF11(IERR,21);
_40:
end;

end.
